# coding: utf-8

"""
    CLOUD API

    An enterprise-grade Infrastructure is provided as a Service (IaaS) solution that can be managed through a browser-based \"Data Center Designer\" (DCD) tool or via an easy to use API.   The API allows you to perform a variety of management tasks such as spinning up additional servers, adding volumes, adjusting networking, and so forth. It is designed to allow users to leverage the same power and flexibility found within the DCD visual tool. Both tools are consistent with their concepts and lend well to making the experience smooth and intuitive.  # noqa: E501

    The version of the OpenAPI document: 5.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud.configuration import Configuration


class LocationProperties(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'features': 'list[str]',
        'image_aliases': 'list[str]',
    }

    attribute_map = {
        'name': 'name',
        'features': 'features',
        'image_aliases': 'imageAliases',
    }

    def __init__(self, name=None, features=None, image_aliases=None, local_vars_configuration=None):  # noqa: E501
        """LocationProperties - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._features = None
        self._image_aliases = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if features is not None:
            self.features = features
        if image_aliases is not None:
            self.image_aliases = image_aliases

    @property
    def name(self):
        """Gets the name of this LocationProperties.  # noqa: E501

        A name of that resource  # noqa: E501

        :return: The name of this LocationProperties.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LocationProperties.

        A name of that resource  # noqa: E501

        :param name: The name of this LocationProperties.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def features(self):
        """Gets the features of this LocationProperties.  # noqa: E501

        List of features supported by the location  # noqa: E501

        :return: The features of this LocationProperties.  # noqa: E501
        :rtype: list[str]
        """
        return self._features

    @features.setter
    def features(self, features):
        """Sets the features of this LocationProperties.

        List of features supported by the location  # noqa: E501

        :param features: The features of this LocationProperties.  # noqa: E501
        :type features: list[str]
        """
        allowed_values = ["SSD", "SSD_STORAGE_ZONING"]  # noqa: E501

        self._features = features

    @property
    def image_aliases(self):
        """Gets the image_aliases of this LocationProperties.  # noqa: E501

        List of image aliases available for the location  # noqa: E501

        :return: The image_aliases of this LocationProperties.  # noqa: E501
        :rtype: list[str]
        """
        return self._image_aliases

    @image_aliases.setter
    def image_aliases(self, image_aliases):
        """Sets the image_aliases of this LocationProperties.

        List of image aliases available for the location  # noqa: E501

        :param image_aliases: The image_aliases of this LocationProperties.  # noqa: E501
        :type image_aliases: list[str]
        """

        self._image_aliases = image_aliases

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LocationProperties):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LocationProperties):
            return True

        return self.to_dict() != other.to_dict()
